 '****************************************************************
' Name    : bstart.BAS 
' Author  :  
' Notice  :    BSTART 
'         :     
' Date    : 16.03.2009        
' Version : 1.0           
' Notes   :      24LC32                              
'****************************************************************
        Device = 16F873
        Xtal = 20
'------------------------------------- -------------------------------------  
'Declare  Optimiser_Level 0    '    
'
Declare Adin_Res 10 ' P    = 10
Declare Adin_Tad 32_FOSC ' ADCON0
Declare Adin_Stime 100 '     50   
ADCON1 = %10001110
'
TRISA =	%11111101
TRISB =	%11110000
TRISC =	%00000000   
OPTION_REG = %10000010
INTCON = %00000000
PIE1 = %00000001
PIE2      = 0
SSPCON    = 0      
CCP1CON   = 0 
CCPR1L    = 0 
CCPR1H    = 0 
CCP2CON   = 0 
CCPR2L    = 0 
CCPR2H    = 0 
T2CON     = 0 
SSPCON    = 0 
T1CON     = 0 
RCSTA     = 0                              
'
'-------------------------------------------- ---------------------------------------------
' 
'___________________________________  (EEPROM)__________________________________________________ 
'
Dim START_V As Word          '       
Dim REVERS_V As Word         '           
Dim TMR_1 As Word            '  _1            
Dim TMR_0 As Byte            '  _0       
'
'                                                                                           
'_____________________________________________________________________________________________   
Dim ANALOG As Word              '    
Dim TASK As Word                '          
Dim TASK_INDICATOR As Word      '        
Dim TASK_DIVISOR As Word        '                                       
Dim DELAY_REALIGNMENT As Byte   '                             
Dim DELAY_REAL As Byte          '                           
Dim NUMBER As Byte              '                                                                           
'_______________________________ ______________________________________________________________
Dim TIME_XI As Word             '       
Dim INDICATOR As Word           '                              
Dim N As Byte                   '    
Dim CYFRA_X As Byte             '    
Dim CYFRA_2 As Byte             ' 2                    
Dim CYFRA_3 As Byte             ' 3        
Dim CYFRA_4 As Byte             ' 4        
'  ________________________________________________________________________ 
'        
PORTC = %11100000 
PORTB = 0 
'NUMBER = 1    
   TMR0 = 0
   TMR_0 = 0 
   TASK = 500          
   TMR_1 = 64535  
   TMR1LH = TMR_1H     
   TMR1L = TMR_1
   DELAY_REAL = 1   
   TASK_DIVISOR = 25
   NUMBER = 1
   '      
   INTCON.2 = 0
   PIR1.0 = 0
   T1CON.0 = 1
INTCON.5 = 0
INTCON.6 = 1  
INTCON.7 = 1 
 '____________________________________________________________________  
                                                      
 On_Interrupt GoTo  Int_Label 
 GoTo  main: 
                    
 '-------------------------- --------------------------                    
 Int_Label: 
 Context Save          
   '______________________________________  _1_________________________________________
'
 If PIR1.0 = 1 Then 
    TMR0 = TMR_0  
    T1CON.0 = 0: PIR1.0 = 0: INTCON.6 = 0: INTCON.5 = 1: INTCON.2 = 0: PORTA.1 = 1 
 EndIf                                                                       
   '______________________________________  _0_________________________________________
'
 If INTCON.2 = 1 Then              
'______________________________________  ________________________________________________
'                     
    DELAY_REAL = DELAY_REAL - 1
  If DELAY_REAL = 0 Then
    DELAY_REAL = DELAY_REALIGNMENT
         If PORTA.2 = 0 Then 
             TASK = TASK + 1
             If TASK > 1000 Then TASK = 1000
         EndIf
         If PORTA.3 = 0 Then 
             TASK = TASK - 1         
             If TASK < 10 Then TASK = 10
         EndIf
  EndIf
	INTCON.6 = 0: T1CON.0 = 0
	DelayUS 1
    TMR1LH = TMR_1H:	TMR1L = TMR_1: INTCON.6 = 1: T1CON.0 = 1: INTCON.2 = 0: INTCON.5 = 0: PORTA.1 = 0 
 EndIf
 '
    Context Restore
 '__________________________________________________________________________________________________________________
 '          
 '______________________________________________ ______________________________________________
 main:                    
'______________________________  ()________________________________________________
        ANALOG = ADIn 0                      '    0- 
'                  
'___________________________________    ,  ____________________________________________
    If ANALOG > TASK Then            
       TMR_1 = TMR_1 + 1
       If TMR_1 >= 65534  Then TMR_1 = 65534 
    Else                                  
       TMR_1 = TMR_1 - 1 
       If TMR_1 <= 1000  Then TMR_1 = 1000
    EndIf                                   
                                                                    
'______________________________________    ________________________________________________
'IND:                             
         BranchL NUMBER, [main, IND_1]', IND_2, IND_3 , IND_3, IND_5, IND_6]', IND_7, IND_8 ]      
'______________________________________    ________________________________________________
 IND_1:
    TASK_INDICATOR = TASK / TASK_DIVISOR
    INDICATOR = TASK_INDICATOR
      GoTo  PREPARATION
'                          
'______________________________________   ________________________________________________
PREPARATION:          
        If INDICATOR >= 100 Then
         CYFRA_2 = INDICATOR / 100: INDICATOR = INDICATOR - ( CYFRA_2 * 100 )
        Else
         CYFRA_2 = 0 
        EndIf
  '   
        If INDICATOR >= 10 Then
         CYFRA_3 = INDICATOR / 10: INDICATOR = INDICATOR - ( CYFRA_3 * 10 )
        Else
         CYFRA_3 = 0
        EndIf
  '
         CYFRA_4 = INDICATOR
'_____________________________   .____________________________________________ 
'                            
'                     
		PORTB.3 = 0       
		CYFRA_X = NUMBER
		GoSub   E_Read   
		PORTB.2 = 1     
 GoSub PERIOD_REPETITION 
' 
		PORTB.2 = 0  
		CYFRA_X = CYFRA_2
		GoSub   E_Read    
		PORTB.1 = 1  
 GoSub PERIOD_REPETITION        
' 
		PORTB.1 = 0    
		CYFRA_X = CYFRA_3
		GoSub   E_Read    
		PORTB.0 = 1   
 GoSub PERIOD_REPETITION  
' 
		PORTB.0 = 0 
		CYFRA_X = CYFRA_4
		GoSub   E_Read     
		PORTB.3 = 1    
 GoSub PERIOD_REPETITION  
    GoTo  main 
'                                                                                                      
Stop  
 '____________________________  0  9  ______________________________________ 
 E_Read:                                   
         BranchL CYFRA_X, [C_0, C_1, C_2, C_3, C_4, C_5, C_6, C_7, C_8, C_9 ]
 C_0:
		PORTC =	%00011000	'0  
 Return                        
 C_1:
		PORTC =	%01111011	'1     
 Return                        
 C_2:
		PORTC =	%01001100	'2     
 Return                        
 C_3:
		PORTC =	%01001001	'3       
 Return                        
 C_4:
		PORTC =	%00101011	'4        
 Return                        
 C_5:
		PORTC =	%10001001	'5     
 Return                        
 C_6:
		PORTC =	%10001000	'6    
 Return                        
 C_7:
		PORTC =	%01011011	'7    
 Return                        
 C_8:
		PORTC =	%00001000	'8    
 Return                        
 C_9:
		PORTC =	%00001001	'9      
 Return  
'		retlw	00010000	;10
'		retlw	01110011	;11
'		retlw	01000100	;12
'		retlw	01000001	;13
'		retlw	00100011	;14                                              
'_________________________    ________________________________________
PERIOD_REPETITION:  
 DelayMS 3.1
Return                               
